<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Automate cellulaire:  Fichier source de src/regle.c</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Automate cellulaire
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Généré par Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Recherche');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Recherche');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">regle.c</div>  </div>
</div><!--header-->
<div class="contents">
<a href="regle_8c.html">Aller à la documentation de ce fichier.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;regle.h&quot;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">//                           Structure                        //</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="structregle.html">   31</a></span>&#160;<span class="comment"></span><span class="keyword">struct </span><a class="code" href="structregle.html">regle</a> {</div>
<div class="line"><a name="l00032"></a><span class="lineno"><a class="line" href="structregle.html#a8c35c594e654c2a92873f1514e46cf28">   32</a></span>&#160;  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structregle.html#a8c35c594e654c2a92873f1514e46cf28">nombre_etat</a>;</div>
<div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="structregle.html#a2260faec26c7e458eac1791a03db49c9">   33</a></span>&#160;  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structregle.html#a2260faec26c7e458eac1791a03db49c9">numero_decimale</a>;</div>
<div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="structregle.html#a821262df99649ddc1d41aede824b65dc">   34</a></span>&#160;  <span class="keywordtype">char</span>* <a class="code" href="structregle.html#a821262df99649ddc1d41aede824b65dc">numero_binaire</a>;</div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="structregle.html#aaee555382d08e4f817d968c8e25e74ad">   35</a></span>&#160;  ptr_str_conf* <a class="code" href="structregle.html#aaee555382d08e4f817d968c8e25e74ad">tab_configuration</a>;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;};</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160; </div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">//                        Constructeur                        //</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="regle_8c.html#a251bd1b86ce38f9b98b2bd4ec42432da">   49</a></span>&#160;<span class="comment"></span><span class="keywordtype">void</span> <a class="code" href="regle_8c.html#a251bd1b86ce38f9b98b2bd4ec42432da">_config_binaire</a>(<span class="keywordtype">char</span>* numero_binaire, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nombre_etat, ptr_str_regle* ptr){</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;  ptr_str_conf* tab = (ptr_str_conf*)malloc( pow(nombre_etat, 3) * <span class="keyword">sizeof</span>(<span class="keyword">struct </span><a class="code" href="structconfiguration.html">configuration</a>*) );</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;  <span class="keywordflow">if</span>(tab == NULL) {</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;     fprintf(stderr, <span class="stringliteral">&quot;L&#39;allocation memoire a echoue.&quot;</span>);</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;     exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;  }</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cpt = 0;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;  <span class="keywordtype">char</span>* temp = (<span class="keywordtype">char</span>*)malloc(<span class="keyword">sizeof</span>(<span class="keywordtype">char</span>) * 8);</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;  <span class="keywordflow">if</span>(temp == NULL) {</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;     fprintf(stderr, <span class="stringliteral">&quot;L&#39;allocation memoire a echoue.&quot;</span>);</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;     exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;  }</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;  <span class="comment">// initialiser les configurations en fonction de la regle donnee</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;  <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i = pow(nombre_etat, 3) - 1; i &gt;= 0; i-- ){</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <a class="code" href="utils_8c.html#a24de25c90e051b42fa3d59a7814b0b7c">decimal_to_binary</a>(&amp;temp, i);</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    tab[cpt] = <a class="code" href="configuration_8c.html#a2da1ecaa0c8bee5b0de11c7a0cf25376">creer_configuration</a>();</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <a class="code" href="configuration_8c.html#a8683ab4db526e75f84e627323f8a4b01">init_configuration_entree</a>(tab[cpt], (<span class="keywordtype">int</span>)temp[5]-<span class="charliteral">&#39;0&#39;</span>, (<span class="keywordtype">int</span>)temp[6]-<span class="charliteral">&#39;0&#39;</span>, (<span class="keywordtype">int</span>)temp[7]-<span class="charliteral">&#39;0&#39;</span>);</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <a class="code" href="configuration_8c.html#ab6f7671e46ec27554e8ab5da3a87e71d">init_configuration_sortie</a>(tab[cpt], (<span class="keywordtype">int</span>)(numero_binaire[cpt]-<span class="charliteral">&#39;0&#39;</span>));</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    cpt++;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;  }</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;  free(temp);</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;  (*ptr)-&gt;tab_configuration = tab;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;}</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160; </div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; </div>
<div class="line"><a name="l00081"></a><span class="lineno"><a class="line" href="regle_8c.html#ac7b95dee8a7e84ea3037cb05a7c963f5">   81</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="regle_8c.html#ac7b95dee8a7e84ea3037cb05a7c963f5">_config_somme</a>(<span class="keywordtype">char</span>* numero_binaire, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nombre_etat, ptr_str_regle* ptr){</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;  ptr_str_conf* tab = (ptr_str_conf*)malloc( ((nombre_etat - 1) * 3 + 1) * <span class="keyword">sizeof</span>(<span class="keyword">struct </span><a class="code" href="structconfiguration.html">configuration</a>*) );</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;  <span class="keywordflow">if</span>(tab == NULL) {</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;     fprintf(stderr, <span class="stringliteral">&quot;L&#39;allocation memoire a echoue.&quot;</span>);</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;     exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;  }</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cpt = 0;</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;  <span class="comment">// initialisation des configurations en fonction de la regle donnee</span></div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;  <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i = ((nombre_etat - 1) * 3 + 1) - 1; i &gt;= 0; i-- ){</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    tab[cpt] = <a class="code" href="configuration_8c.html#a2da1ecaa0c8bee5b0de11c7a0cf25376">creer_configuration</a>();</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <a class="code" href="configuration_8c.html#ab6f7671e46ec27554e8ab5da3a87e71d">init_configuration_sortie</a>(tab[cpt], (<span class="keywordtype">int</span>)numero_binaire[cpt]-<span class="charliteral">&#39;0&#39;</span>);</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    cpt++;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;  }</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;  (*ptr)-&gt;tab_configuration = tab;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;}</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160; </div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160; </div>
<div class="line"><a name="l00105"></a><span class="lineno"><a class="line" href="regle_8c.html#a66825a41280d604f6cd3c8b5f373a7ee">  105</a></span>&#160;ptr_str_regle <a class="code" href="regle_8c.html#a66825a41280d604f6cd3c8b5f373a7ee">creer_regle</a>(<span class="keywordtype">char</span>* numero, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nombre_etat){</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;  ptr_str_regle ptr = (ptr_str_regle)malloc( <span class="keyword">sizeof</span>(<span class="keyword">struct</span> <a class="code" href="structregle.html">regle</a>) );</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;  <span class="keywordflow">if</span>(ptr == NULL) {</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;     fprintf(stderr, <span class="stringliteral">&quot;L&#39;allocation memoire a echoue.&quot;</span>);</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;     exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;  }</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;  ptr-&gt;nombre_etat = nombre_etat;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;  ptr-&gt;numero_decimale = <a class="code" href="utils_8c.html#a3b7908e8916a52b84521dfee1c9fa0d3">binary_to_decimal</a>(numero);</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;  ptr-&gt;numero_binaire = numero;</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;  <span class="comment">// la regle est creee en fonction du nombre d&#39;etats de l&#39;automate</span></div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;  <span class="comment">// s&#39;il y en a 2 alors, il va creer les configurations avec la fonction _config_binaire</span></div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;  <span class="keywordflow">if</span>(nombre_etat == 2){</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <a class="code" href="regle_8c.html#a012109f6ea56e4d9315d79f8a8f3f8e0">creer_tableau_configuration</a>(ptr-&gt;numero_binaire, nombre_etat, ptr, &amp;<a class="code" href="regle_8c.html#a251bd1b86ce38f9b98b2bd4ec42432da">_config_binaire</a>);</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;  }</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;  <span class="comment">// sinon la fonction _config_somme sera utilisee</span></div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;  <span class="keywordflow">else</span>{</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <a class="code" href="regle_8c.html#a012109f6ea56e4d9315d79f8a8f3f8e0">creer_tableau_configuration</a>(ptr-&gt;numero_binaire, nombre_etat, ptr, &amp;<a class="code" href="regle_8c.html#ac7b95dee8a7e84ea3037cb05a7c963f5">_config_somme</a>);</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;  }</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;  <span class="keywordflow">return</span> ptr;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;}</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160; </div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160; </div>
<div class="line"><a name="l00135"></a><span class="lineno"><a class="line" href="regle_8c.html#a012109f6ea56e4d9315d79f8a8f3f8e0">  135</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="regle_8c.html#a012109f6ea56e4d9315d79f8a8f3f8e0">creer_tableau_configuration</a>(<span class="keywordtype">char</span>* numero_binaire, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nombre_etat, ptr_str_regle ptr, <span class="keywordtype">void</span>(*_config)(<span class="keywordtype">char</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, ptr_str_regle*)){</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;  (*_config)( numero_binaire, nombre_etat, &amp;ptr);</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;}</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160; </div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="comment">//                       Autres Fonctions                     //</span></div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00149"></a><span class="lineno"><a class="line" href="regle_8c.html#a73aeb391bdf6be3f730c3d725360257a">  149</a></span>&#160;<span class="comment"></span><span class="keywordtype">int</span> <a class="code" href="regle_8c.html#a73aeb391bdf6be3f730c3d725360257a">recherche_configuration</a>(ptr_str_regle <a class="code" href="structregle.html">regle</a>, ptr_str_conf conf){</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; pow(<a class="code" href="structregle.html">regle</a>-&gt;<a class="code" href="structregle.html#a8c35c594e654c2a92873f1514e46cf28">nombre_etat</a>, 3); i++) {</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    <span class="keywordflow">if</span> (<a class="code" href="configuration_8c.html#ab64d6ac48d2c2034a1f505bc2d174154">cmp_conf</a>(<a class="code" href="structregle.html">regle</a>-&gt;<a class="code" href="structregle.html#aaee555382d08e4f817d968c8e25e74ad">tab_configuration</a>[i], conf)){</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;      <span class="keywordflow">return</span> <a class="code" href="configuration_8c.html#a9555a26a5ba14b904e676207072cc5af">get_etat_sortie</a>(<a class="code" href="structregle.html">regle</a>-&gt;<a class="code" href="structregle.html#aaee555382d08e4f817d968c8e25e74ad">tab_configuration</a>[i]);</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    }</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;  }</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;  printf(<span class="stringliteral">&quot;Erreur lors de la recherche de la configuration.\n&quot;</span>);</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;  exit(0);</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;}</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160; </div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160; </div>
<div class="line"><a name="l00167"></a><span class="lineno"><a class="line" href="regle_8c.html#ad852e50dfdd6aa3660731b37de177d2c">  167</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="regle_8c.html#ad852e50dfdd6aa3660731b37de177d2c">recherche_indice</a>(ptr_str_regle <a class="code" href="structregle.html">regle</a>, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> indice){</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;  <span class="keywordflow">return</span> <a class="code" href="configuration_8c.html#a9555a26a5ba14b904e676207072cc5af">get_etat_sortie</a>(<a class="code" href="structregle.html">regle</a>-&gt;<a class="code" href="structregle.html#aaee555382d08e4f817d968c8e25e74ad">tab_configuration</a>[indice]);</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;}</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160; </div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160; </div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;<span class="comment">//                           Accesseurs                       //</span></div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00181"></a><span class="lineno"><a class="line" href="regle_8c.html#a46e5c74eda89fcaf925f91806d5bf86c">  181</a></span>&#160;<span class="comment"></span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="regle_8c.html#a46e5c74eda89fcaf925f91806d5bf86c">get_nombre_etat</a>( ptr_str_regle ptr ){</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;  <span class="keywordflow">return</span> ptr-&gt;nombre_etat;</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;}</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160; </div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160; </div>
<div class="line"><a name="l00192"></a><span class="lineno"><a class="line" href="regle_8c.html#abb64bb8f15528e167294857d015a193a">  192</a></span>&#160;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="regle_8c.html#abb64bb8f15528e167294857d015a193a">get_numero_decimale</a>( ptr_str_regle ptr ){</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;  <span class="keywordflow">return</span> ptr-&gt;numero_decimale;</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;}</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160; </div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160; </div>
<div class="line"><a name="l00203"></a><span class="lineno"><a class="line" href="regle_8c.html#ab5f4f5a6960efe9d383d86c67c4f7190">  203</a></span>&#160;<span class="keywordtype">char</span>* <a class="code" href="regle_8c.html#ab5f4f5a6960efe9d383d86c67c4f7190">get_numero_binaire</a>( ptr_str_regle ptr ){</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;  <span class="keywordflow">return</span> ptr-&gt;numero_binaire;</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;}</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160; </div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160; </div>
<div class="line"><a name="l00214"></a><span class="lineno"><a class="line" href="regle_8c.html#ac7ca766573256b9fdbf502eed89d98e9">  214</a></span>&#160;ptr_str_conf* <a class="code" href="regle_8c.html#ac7ca766573256b9fdbf502eed89d98e9">get_tab_configuration</a>( ptr_str_regle ptr ){</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;  <span class="keywordflow">return</span> ptr-&gt;tab_configuration;</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;}</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160; </div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;<span class="comment">//                        Destruction                         //</span></div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00226"></a><span class="lineno"><a class="line" href="regle_8c.html#a12710fa473da40d460ea41037c23ade9">  226</a></span>&#160;<span class="comment"></span><span class="keywordtype">void</span> <a class="code" href="regle_8c.html#a12710fa473da40d460ea41037c23ade9">delete_regle</a>(ptr_str_regle* ptr){</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> taille_tab;</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;  <span class="keywordflow">if</span> ((*ptr)-&gt;nombre_etat == 2){</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;    taille_tab = pow((*ptr)-&gt;nombre_etat, 3);</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;  }</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;  <span class="keywordflow">else</span>{</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    taille_tab = ((*ptr)-&gt;nombre_etat - 1) * 3 + 1;</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;  }</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; taille_tab; i++) {</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;    free((*ptr)-&gt;tab_configuration[i]);</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;  }</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;  free((*ptr)-&gt;tab_configuration);</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;  <span class="keywordflow">if</span> ((*ptr)-&gt;nombre_etat == 2){</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;    free((*ptr)-&gt;numero_binaire);</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;  }</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;  free((*ptr));</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;  *ptr = NULL;</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;}</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160; </div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160; </div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;<span class="comment">//                          Affichage                         //</span></div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00254"></a><span class="lineno"><a class="line" href="regle_8c.html#a3f644974675b843554ffe9330ef4846b">  254</a></span>&#160;<span class="comment"></span><span class="keywordtype">void</span> <a class="code" href="regle_8c.html#a3f644974675b843554ffe9330ef4846b">afficher_regle</a>( ptr_str_regle ptr ){</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> taille_tab;</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;  <span class="comment">// affichage pour 2 etats</span></div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;  <span class="keywordflow">if</span> (ptr-&gt;nombre_etat == 2){</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;    taille_tab = pow(ptr-&gt;nombre_etat, 3);</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;    <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; taille_tab; i++){</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;      <a class="code" href="configuration_8c.html#ad6bae512bff79422335f1132a8ac5695">afficher_configuration_elementaire</a>(ptr-&gt;tab_configuration[i]);</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;    }</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;  }</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;  <span class="comment">// affichage pour 3 etats ou plus</span></div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;  <span class="keywordflow">else</span>{</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;    taille_tab = (ptr-&gt;nombre_etat - 1) * 3 + 1;</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; taille_tab; i++){</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;      <a class="code" href="configuration_8c.html#a0142d10519eacf9f6489fc21cdcaa759">afficher_configuration_multiple</a>(ptr-&gt;tab_configuration[i], i);</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;    }</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;  }</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160; </div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;}</div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aregle_8c_html_a12710fa473da40d460ea41037c23ade9"><div class="ttname"><a href="regle_8c.html#a12710fa473da40d460ea41037c23ade9">delete_regle</a></div><div class="ttdeci">void delete_regle(ptr_str_regle *ptr)</div><div class="ttdoc">Desallouer la memoire de la regle.</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00226">regle.c:226</a></div></div>
<div class="ttc" id="aregle_8c_html_ac7ca766573256b9fdbf502eed89d98e9"><div class="ttname"><a href="regle_8c.html#ac7ca766573256b9fdbf502eed89d98e9">get_tab_configuration</a></div><div class="ttdeci">ptr_str_conf * get_tab_configuration(ptr_str_regle ptr)</div><div class="ttdoc">Retourne l'attribut tab configuration.</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00214">regle.c:214</a></div></div>
<div class="ttc" id="aconfiguration_8c_html_a2da1ecaa0c8bee5b0de11c7a0cf25376"><div class="ttname"><a href="configuration_8c.html#a2da1ecaa0c8bee5b0de11c7a0cf25376">creer_configuration</a></div><div class="ttdeci">ptr_str_conf creer_configuration()</div><div class="ttdoc">Créer une structure configuration en initialisant ses valeurs à 0.</div><div class="ttdef"><b>Definition:</b> <a href="configuration_8c_source.html#l00048">configuration.c:48</a></div></div>
<div class="ttc" id="aconfiguration_8c_html_a8683ab4db526e75f84e627323f8a4b01"><div class="ttname"><a href="configuration_8c.html#a8683ab4db526e75f84e627323f8a4b01">init_configuration_entree</a></div><div class="ttdeci">void init_configuration_entree(ptr_str_conf ptr, unsigned int gauche, unsigned int centre, unsigned int droite)</div><div class="ttdoc">Initialise les valeurs pour une structure configuration donnée.</div><div class="ttdef"><b>Definition:</b> <a href="configuration_8c_source.html#l00073">configuration.c:73</a></div></div>
<div class="ttc" id="aregle_8c_html_ab5f4f5a6960efe9d383d86c67c4f7190"><div class="ttname"><a href="regle_8c.html#ab5f4f5a6960efe9d383d86c67c4f7190">get_numero_binaire</a></div><div class="ttdeci">char * get_numero_binaire(ptr_str_regle ptr)</div><div class="ttdoc">Retourne l'attribut &quot;numero_binaire&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00203">regle.c:203</a></div></div>
<div class="ttc" id="astructconfiguration_html"><div class="ttname"><a href="structconfiguration.html">configuration</a></div><div class="ttdoc">Une configuration.</div><div class="ttdef"><b>Definition:</b> <a href="configuration_8c_source.html#l00032">configuration.c:32</a></div></div>
<div class="ttc" id="astructregle_html"><div class="ttname"><a href="structregle.html">regle</a></div><div class="ttdoc">Une regle.</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00031">regle.c:31</a></div></div>
<div class="ttc" id="aregle_8c_html_a3f644974675b843554ffe9330ef4846b"><div class="ttname"><a href="regle_8c.html#a3f644974675b843554ffe9330ef4846b">afficher_regle</a></div><div class="ttdeci">void afficher_regle(ptr_str_regle ptr)</div><div class="ttdoc">Affiche une regle (l'ensemble des configurations)</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00254">regle.c:254</a></div></div>
<div class="ttc" id="aregle_8c_html_a66825a41280d604f6cd3c8b5f373a7ee"><div class="ttname"><a href="regle_8c.html#a66825a41280d604f6cd3c8b5f373a7ee">creer_regle</a></div><div class="ttdeci">ptr_str_regle creer_regle(char *numero, unsigned int nombre_etat)</div><div class="ttdoc">Créer une structure regle.</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00105">regle.c:105</a></div></div>
<div class="ttc" id="astructregle_html_a821262df99649ddc1d41aede824b65dc"><div class="ttname"><a href="structregle.html#a821262df99649ddc1d41aede824b65dc">regle::numero_binaire</a></div><div class="ttdeci">char * numero_binaire</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00034">regle.c:34</a></div></div>
<div class="ttc" id="autils_8c_html_a3b7908e8916a52b84521dfee1c9fa0d3"><div class="ttname"><a href="utils_8c.html#a3b7908e8916a52b84521dfee1c9fa0d3">binary_to_decimal</a></div><div class="ttdeci">int binary_to_decimal(char *binary)</div><div class="ttdoc">Convertit un nombre binaire en decimal.</div><div class="ttdef"><b>Definition:</b> <a href="utils_8c_source.html#l00049">utils.c:49</a></div></div>
<div class="ttc" id="aconfiguration_8c_html_a9555a26a5ba14b904e676207072cc5af"><div class="ttname"><a href="configuration_8c.html#a9555a26a5ba14b904e676207072cc5af">get_etat_sortie</a></div><div class="ttdeci">unsigned int get_etat_sortie(ptr_str_conf ptr)</div><div class="ttdoc">Retourne l'attribut etat_sortie.</div><div class="ttdef"><b>Definition:</b> <a href="configuration_8c_source.html#l00133">configuration.c:133</a></div></div>
<div class="ttc" id="astructregle_html_aaee555382d08e4f817d968c8e25e74ad"><div class="ttname"><a href="structregle.html#aaee555382d08e4f817d968c8e25e74ad">regle::tab_configuration</a></div><div class="ttdeci">ptr_str_conf * tab_configuration</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00035">regle.c:35</a></div></div>
<div class="ttc" id="aregle_8c_html_abb64bb8f15528e167294857d015a193a"><div class="ttname"><a href="regle_8c.html#abb64bb8f15528e167294857d015a193a">get_numero_decimale</a></div><div class="ttdeci">unsigned int get_numero_decimale(ptr_str_regle ptr)</div><div class="ttdoc">Retourne l'attribut &quot;numero_decimale&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00192">regle.c:192</a></div></div>
<div class="ttc" id="astructregle_html_a8c35c594e654c2a92873f1514e46cf28"><div class="ttname"><a href="structregle.html#a8c35c594e654c2a92873f1514e46cf28">regle::nombre_etat</a></div><div class="ttdeci">unsigned int nombre_etat</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00032">regle.c:32</a></div></div>
<div class="ttc" id="aregle_8c_html_a46e5c74eda89fcaf925f91806d5bf86c"><div class="ttname"><a href="regle_8c.html#a46e5c74eda89fcaf925f91806d5bf86c">get_nombre_etat</a></div><div class="ttdeci">unsigned int get_nombre_etat(ptr_str_regle ptr)</div><div class="ttdoc">Retourne l'attribut &quot;nombre_etat&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00181">regle.c:181</a></div></div>
<div class="ttc" id="aregle_8c_html_ac7b95dee8a7e84ea3037cb05a7c963f5"><div class="ttname"><a href="regle_8c.html#ac7b95dee8a7e84ea3037cb05a7c963f5">_config_somme</a></div><div class="ttdeci">void _config_somme(char *numero_binaire, unsigned int nombre_etat, ptr_str_regle *ptr)</div><div class="ttdoc">Créer un tableau de configuration avec plus de 3 etats.</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00081">regle.c:81</a></div></div>
<div class="ttc" id="aregle_8c_html_ad852e50dfdd6aa3660731b37de177d2c"><div class="ttname"><a href="regle_8c.html#ad852e50dfdd6aa3660731b37de177d2c">recherche_indice</a></div><div class="ttdeci">int recherche_indice(ptr_str_regle regle, unsigned int indice)</div><div class="ttdoc">Trouve la valeur de la sortie a partir de l'indice donnee en parametre.</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00167">regle.c:167</a></div></div>
<div class="ttc" id="aconfiguration_8c_html_ab64d6ac48d2c2034a1f505bc2d174154"><div class="ttname"><a href="configuration_8c.html#ab64d6ac48d2c2034a1f505bc2d174154">cmp_conf</a></div><div class="ttdeci">bool cmp_conf(ptr_str_conf conf1, ptr_str_conf conf2)</div><div class="ttdoc">Compare uniquement les valeurs des états de gauche, du centre et de droite entre conf1 et conf2.</div><div class="ttdef"><b>Definition:</b> <a href="configuration_8c_source.html#l00150">configuration.c:150</a></div></div>
<div class="ttc" id="aconfiguration_8c_html_ad6bae512bff79422335f1132a8ac5695"><div class="ttname"><a href="configuration_8c.html#ad6bae512bff79422335f1132a8ac5695">afficher_configuration_elementaire</a></div><div class="ttdeci">void afficher_configuration_elementaire(ptr_str_conf ptr)</div><div class="ttdoc">Affiche les attributs d'une configuration.</div><div class="ttdef"><b>Definition:</b> <a href="configuration_8c_source.html#l00163">configuration.c:163</a></div></div>
<div class="ttc" id="autils_8c_html_a24de25c90e051b42fa3d59a7814b0b7c"><div class="ttname"><a href="utils_8c.html#a24de25c90e051b42fa3d59a7814b0b7c">decimal_to_binary</a></div><div class="ttdeci">char * decimal_to_binary(char **ptr_char, unsigned int val)</div><div class="ttdoc">Convertir un nombre decimal entre 0 et 256 en binaire.</div><div class="ttdef"><b>Definition:</b> <a href="utils_8c_source.html#l00027">utils.c:27</a></div></div>
<div class="ttc" id="aregle_8c_html_a012109f6ea56e4d9315d79f8a8f3f8e0"><div class="ttname"><a href="regle_8c.html#a012109f6ea56e4d9315d79f8a8f3f8e0">creer_tableau_configuration</a></div><div class="ttdeci">void creer_tableau_configuration(char *numero_binaire, unsigned int nombre_etat, ptr_str_regle ptr, void(*_config)(char *, unsigned int, ptr_str_regle *))</div><div class="ttdoc">Créer un tbleau de configuration en fonction du nombre d'état possible.</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00135">regle.c:135</a></div></div>
<div class="ttc" id="aconfiguration_8c_html_a0142d10519eacf9f6489fc21cdcaa759"><div class="ttname"><a href="configuration_8c.html#a0142d10519eacf9f6489fc21cdcaa759">afficher_configuration_multiple</a></div><div class="ttdeci">void afficher_configuration_multiple(ptr_str_conf ptr, unsigned int indice)</div><div class="ttdoc">Affiche une configuration à plus de 2 états.</div><div class="ttdef"><b>Definition:</b> <a href="configuration_8c_source.html#l00177">configuration.c:177</a></div></div>
<div class="ttc" id="aregle_8c_html_a251bd1b86ce38f9b98b2bd4ec42432da"><div class="ttname"><a href="regle_8c.html#a251bd1b86ce38f9b98b2bd4ec42432da">_config_binaire</a></div><div class="ttdeci">void _config_binaire(char *numero_binaire, unsigned int nombre_etat, ptr_str_regle *ptr)</div><div class="ttdoc">Créer un tableau de configuration pour deux etats.</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00049">regle.c:49</a></div></div>
<div class="ttc" id="aconfiguration_8c_html_ab6f7671e46ec27554e8ab5da3a87e71d"><div class="ttname"><a href="configuration_8c.html#ab6f7671e46ec27554e8ab5da3a87e71d">init_configuration_sortie</a></div><div class="ttdeci">void init_configuration_sortie(ptr_str_conf ptr, unsigned int sortie)</div><div class="ttdoc">Initialise la valeurs de sortie pour une structure configuration donnée.</div><div class="ttdef"><b>Definition:</b> <a href="configuration_8c_source.html#l00086">configuration.c:86</a></div></div>
<div class="ttc" id="aregle_8c_html_a73aeb391bdf6be3f730c3d725360257a"><div class="ttname"><a href="regle_8c.html#a73aeb391bdf6be3f730c3d725360257a">recherche_configuration</a></div><div class="ttdeci">int recherche_configuration(ptr_str_regle regle, ptr_str_conf conf)</div><div class="ttdoc">Trouve la valeur de la sortie de la configuration passé en paramètre à partir d'une configuration ide...</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00149">regle.c:149</a></div></div>
<div class="ttc" id="astructregle_html_a2260faec26c7e458eac1791a03db49c9"><div class="ttname"><a href="structregle.html#a2260faec26c7e458eac1791a03db49c9">regle::numero_decimale</a></div><div class="ttdeci">unsigned int numero_decimale</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00033">regle.c:33</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Généré par &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
